package labtwo;

import java.awt.*;
import java.awt.geom.Point2D;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 * Date: 4/11/12
 * Time: 8:07 PM
 */
public class LemniscateParamDrawer implements LemniscateDrawer {
    double tt;
    
    double calcX(double t) {
        return (t + t * tt) / (1 + tt * tt);
    }
    
    double calcY(double t) {
        return (t - t * tt) / (1 + tt * tt);
    }
    
    double calcDX(double t) {
        double up = (-tt * tt * tt -3 * tt * tt + 3 * tt + 1);
        double down = (tt * tt + 1);
        down *= down;
        return up / down;
    }

    double calcDY(double t) {
        double up = (tt * tt * tt -3 * tt * tt - 3 * tt + 1);
        double down = (tt * tt + 1);
        down *= down;
        return up / down;
    }

    @Override
    public void draw(PlotPanel p, Graphics2D g, Point2D.Double focus_a, Point2D.Double focus_b) {
        Color prev_color = g.getColor();
        g.setColor(Color.BLUE);
        double a = focus_a.distance(focus_b) / 2.0 * Math.sqrt(2);
        LemniscateTransformator transform = new LemniscateTransformator(focus_a, focus_b);
        System.err.println(focus_a);
        System.err.println(focus_b);
        System.err.println("distance = " + a);
        for(double t = 0.0; ; ) {
            tt = t * t;
            double x = a * calcX(t);
            double y = a * calcY(t);
            transform.go(x, y);
            p.drawPixel(g, transform.x, transform.y);

            x = a * calcX(-t);
            y = a * calcY(-t);
            transform.go(x, y);
            p.drawPixel(g, transform.x, transform.y);

            double dx = a * calcDX(t);
            double dy = a * calcDY(t);
            double h = Math.sqrt(dx * dx + dy * dy) * p.getAxesStep();
            t += 1.0 / h;
            //System.err.println(" t = " + t);
            
            if(Double.isNaN(t)) break;
        }
        g.setColor(prev_color);
    }
}
