package labtwo;

import java.awt.geom.Point2D;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 * Date: 4/11/12
 * Time: 9:24 PM
 */
public class LemniscateTransformator {
    private final Point2D.Double focus_a, focus_b;
    private final double shift_x, shift_y;
    private final double angle;
    private final double precos, presin;
    double x, y;

    LemniscateTransformator(Point2D.Double f1, Point2D.Double f2) {
        focus_a = f1;
        focus_b = f2;
        
        shift_x = (f1.x + f2.x) / 2;
        shift_y = (f1.y + f2.y) / 2;
        
        angle = Math.atan2(f1.y - f2.y, f1.x - f2.x);
        precos = Math.cos(angle);
        presin = Math.sin(angle);
    }
    
    void go(double prex, double prey) {
        x = prex * precos - prey * presin + shift_x;
        y = prex * presin + prey * precos + shift_y;
    }
}
