package labtwo;

import java.awt.*;
import java.awt.geom.Point2D;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 * Date: 4/12/12
 * Time: 12:27 AM
 */
public class SomeFunctionDrawer {
    double tt;

    double calcX(double t) {
        return tt / (tt - 1);
    }

    double calcY(double t) {
        return (tt + 1) / (t + 1);
    }

    double calcDX(double t) {
        return -2 * t / ((tt - 1) * (tt - 1));
    }

    double calcDY(double t) {
        return (tt + 2 * t - 1) / ((t + 1) * (t + 1));
    }

    void go(double t, PlotPanel p, Graphics2D g, int dir) {
        int iteration = 0;
        tt = t * t;
        double nx = calcX(t);
        double ny = calcY(t);
        for(; /*iteration < 10000*/; iteration++) {
            tt = t * t;
            double x = nx;
            double y = ny;
            p.drawPixel(g, x, y);

            double dx = calcDX(t);
            double dy = calcDY(t);
            double h = Math.sqrt(dx * dx + dy * dy) * p.getAxesStep() * 2.0;
            t += dir / h;

            //System.err.println("t = " + t + ", h = " + h);
            if(Double.isNaN(t)) break;
            nx = calcX(t);
            ny = calcY(t);
            if(Math.abs(nx) * p.getAxesStep() <= p.getWidth() && Math.abs(ny) * p.getAxesStep() <= p.getHeight())
                continue;
            if(Math.abs(nx) > Math.abs(x) || Math.abs(ny) > Math.abs(y)) break;
        }
    }

    public void draw(PlotPanel p, Graphics2D g) {
        Color prev_color = g.getColor();
        g.setColor(Color.CYAN);
        final double eps = 1e-1;
        go(1.0 + eps, p, g, 1);
        go(1.0 + eps, p, g, -1);
        go(1.0 - eps, p, g, 1);
        go(1.0 - eps, p, g, -1);
        //go(-1.0 + eps, p, g, 1);
        //go(-1.0 + eps, p, g, -1);
        go(-1.0 - eps, p, g, 1);
        go(-1.0 - eps, p, g, -1);
        g.setColor(prev_color);
    }
}
